//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace TestClient.MetadataConsumerTest
{
    
    
    /// <summary>
    /// Class that implements the IMetadataConsumerTest interface through SiLA2
    /// </summary>
    public partial class MetadataConsumerTestClient : IMetadataConsumerTest, System.ComponentModel.INotifyPropertyChanged, System.IDisposable
    {
        
        private System.Lazy<string> _receivedStringMetadata;
        
        private string _receivedStringMetadataAsCharacters;
        
        private System.Threading.Tasks.Task _receivedStringMetadataAsCharactersUpdateTask;
        
        private System.Threading.CancellationTokenSource _cancellationTokenSource = new System.Threading.CancellationTokenSource();
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.metadataconsumertest.v1.MetadataConsumerTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public MetadataConsumerTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider" feature and returns the metadata value.
        /// </summary>
        public virtual string ReceivedStringMetadata
        {
            get
            {
                return _receivedStringMetadata.Value;
            }
        }
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider" feature and returns all characters of its string value as separate responses.
        /// </summary>
        public virtual string ReceivedStringMetadataAsCharacters
        {
            get
            {
                if ((_receivedStringMetadataAsCharactersUpdateTask == null))
                {
                    try
                    {
                        System.Threading.Monitor.Enter(_cancellationTokenSource);
                        if ((_receivedStringMetadataAsCharactersUpdateTask == null))
                        {
                            _receivedStringMetadataAsCharactersUpdateTask = _channel.SubscribeProperty<ReceivedStringMetadataAsCharactersResponseDto>(_serviceName, "ReceivedStringMetadataAsCharacters", "org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadataAsCh" +
                                    "aracters", ReceiveNewReceivedStringMetadataAsCharacters, _executionManager.CreateCallOptions("org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadataAsCh" +
                                        "aracters"), _cancellationTokenSource.Token);
                        }
                    } finally
                    {
                        System.Threading.Monitor.Exit(_cancellationTokenSource);
                    }
                }
                return _receivedStringMetadataAsCharacters;
            }
        }
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        private string RequestReceivedStringMetadata()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadata");
            try
            {
                string response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.StringDto>>(_serviceName, "ReceivedStringMetadata", "org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadata", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private void ReceiveNewReceivedStringMetadataAsCharacters(ReceivedStringMetadataAsCharactersResponseDto receivedStringMetadataAsCharacters)
        {
            string inner = receivedStringMetadataAsCharacters.Value.Extract(_executionManager.DownloadBinaryStore);
            if ((_receivedStringMetadataAsCharacters != inner))
            {
                _receivedStringMetadataAsCharacters = inner;
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if ((handler != null))
                {
                    handler.Invoke(this, new System.ComponentModel.PropertyChangedEventArgs("ReceivedStringMetadataAsCharacters"));
                }
            }
        }
        
        /// <summary>
        /// Disposes the current client and cancels all subscriptions
        /// </summary>
        public void Dispose()
        {
            _cancellationTokenSource.Cancel();
            _cancellationTokenSource.Dispose();
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _receivedStringMetadata = new System.Lazy<string>(RequestReceivedStringMetadata);
        }
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider Test" feature and responds with its value.
        /// </summary>
        public virtual string EchoStringMetadata()
        {
            EchoStringMetadataRequestDto request = new EchoStringMetadataRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/MetadataConsumerTest/v1/Command/EchoStringMetadata");
            try
            {
                string response = _channel.ExecuteUnobservableCommand<EchoStringMetadataRequestDto, EchoStringMetadataResponseDto>(_serviceName, "EchoStringMetadata", request, callInfo).ReceivedStringMetadata.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Expects the "String Metadata" and "Two Integers Metadata" metadata from the "Metadata Provider Test" feature and responds with all three data items.
        /// </summary>
        public virtual UnpackMetadataResponse UnpackMetadata()
        {
            UnpackMetadataRequestDto request = new UnpackMetadataRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/MetadataConsumerTest/v1/Command/UnpackMetadata");
            try
            {
                UnpackMetadataResponse response = _channel.ExecuteUnobservableCommand<UnpackMetadataRequestDto, UnpackMetadataResponseDto>(_serviceName, "UnpackMetadata", request, callInfo).Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Metadata Consumer Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class MetadataConsumerTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/MetadataConsumerTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IMetadataConsumerTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new MetadataConsumerTestClient(channel, executionManager);
        }
    }
}

